/*****************************  Globals   *************************************/                 
const nsGMailSMTPClassID = Components.ID("{09c77b00-b437-11da-a94d-0800200c9a66}");
const nsGMailSMTPContactID = "@mozilla.org/GMailSMTP;1";
const ExtGMailGuid = "{42040a50-44a3-11da-8cd6-0800200c9a66}";

const szVersionNumber = "V20060829100000";

const PatternGMailGetSessionCookie = /GMAIL_AT=(.*?);/i
const PatternGMailGetLoginCookie = /.*GX=(.*);/
const patternGMailLoginRedirect = /CheckCookie\?continue=(.*?)';/i

// const patternGMailCompose = /location="*(http:\/\/.*?Compose\?YY=.*?)"*/i;
// const patternGMailComposeForm = /<form.*?name="*Compose"*.*?>[\S\s]*?<\/form>/igm;
// const patternGMailAttachmentForm = /<form.*?name="*Attachments"*.*?>[\S\s]*?<\/form>/igm;
// const patternGMailAttachCheck = /javascript\:VirusScanResults\(0\)/igm;

/******************************  GMail ***************************************/
function nsGMailSMTP()
{
	try
	{
		var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
		scriptLoader = scriptLoader.getService(Components.interfaces.mozIJSSubScriptLoader);
		scriptLoader.loadSubScript("chrome://web-mail/content/common/DebugLog.js");
		scriptLoader.loadSubScript("chrome://web-mail/content/common/Email.js");
		scriptLoader.loadSubScript("chrome://web-mail/content/common/CommonPrefs.js");
		scriptLoader.loadSubScript("chrome://web-mail/content/common/comms.js");
		scriptLoader.loadSubScript("chrome://web-mail/content/common/base64.js");
		scriptLoader.loadSubScript("chrome://gmail/content/GMailMSG.js");

		var date = new Date();
		var szLogFileName = "GMailLog_" + date.getHours()+ "_" + date.getMinutes() + "_"+ date.getUTCMilliseconds() +"_";
		// var szLogFileName = "GMailLog_";
		this.m_Log = new DebugLog("webmail.logging.comms", ExtGMailGuid, szLogFileName); 

		this.m_Log.Write("nsGMailSMTP.js " + szVersionNumber + " - Constructor - START");

		this.m_szMailURL = "https://mail.google.com/mail/"
		this.m_bAuthorised = false;
		this.m_szUserName = null;
		this.m_szPassWord = null;
		this.m_oResponseStream = null;
		this.m_HttpComms = new Comms(this , this.m_Log);
		this.m_iStage = 0; 
		this.m_szGMailAtCookie = null;
		this.m_aMsgDataStore = new Array();
		this.m_iTotalSize = 0;
		this.m_Email = new email(this.m_Log);
		this.m_base64 = new base64();
		this.m_Email.decodeBody(true);
		this.m_aszTo = new Array;
		this.m_szFrom = null;
		this.m_szCookieLoginURL = null;

		// this.m_bReEntry = false;
		// this.m_bAttHandled = false;

		this.m_szMsgID = 0;
		this.m_Log.Write("nsGMailSMTP.js - Constructor - END");  

		this.m_SessionManager = Components.classes["@mozilla.org/SessionManager;1"];
		this.m_SessionManager = this.m_SessionManager.getService();
		this.m_SessionManager.QueryInterface(Components.interfaces.nsISessionManager); 
		this.m_SessionData = null;

		//do i reuse the session
		var oPref = new Object();
		oPref.Value = null;
		var  WebMailPrefAccess = new WebMailCommonPrefAccess();
		if (WebMailPrefAccess.Get("bool","gmail.bReUseSession",oPref))
			this.m_bReUseSession = oPref.Value;
		else
			this.m_bReUseSession = false; 

		this.m_Log.Write("nsGMailSMTP.js - Constructor - bReUseSession : " + this.m_bReUseSession);

		//do i save copy
		/*
		var oPref = new Object();
		oPref.Value = null;
		var  PrefAccess = new WebMailCommonPrefAccess();
		if (PrefAccess.Get("bool","gmail.bSaveCopy",oPref))
			this.m_bSaveCopy = oPref.Value;
		else
			this.m_bSaveCopy = true;
		delete oPref;
		this.m_Log.Write("nsGMailSMTP.js - Constructor - bSaveCopy : " + this.m_bSaveCopy);
		*/

		this.m_Log.Write("nsGMailSMTP.js - Constructor - END");
	}
	catch(e) {
		DebugDump("nsGMailSMTP.js: Constructor : Exception : " + e.name + ".\nError message: " + e.message +"\n" + e.lineNumber);
	}
}

nsGMailSMTP.prototype =
{
	get userName() {return this.m_szUserName;},
	set userName(userName) {return this.m_szUserName = userName;},
	
	get passWord() {return this.m_szPassWord;},
	set passWord(passWord) {return this.m_szPassWord = passWord;},
	
	get bAuthorised() {return this.m_bAuthorised;},
	
	get ResponseStream() {return this.m_oResponseStream;},
	set ResponseStream(responseStream) {return this.m_oResponseStream = responseStream;},
	
	get to() {return this.m_aszTo;},
	set to(szAddress) {return this.m_aszTo.push(szAddress);},

	get from() {return this.m_szFrom;},
	set from(szAddress) {return this.m_szFrom = szAddress;},

	logIn : function()
	{
		try {
			this.m_Log.Write("nsGMailSMTP.js - logIN - START");   
			this.m_Log.Write("nsGMailSMTP.js - logIN - Username: " + this.m_szUserName + " Password: " + this.m_szPassWord + " stream: " + this.m_oResponseStream);
	
			if (!this.m_szUserName || !this.m_oResponseStream  || !this.m_szPassWord) return false;
	
			// get login webPage
			var loginURL = 'https://www.google.com/accounts/ServiceLoginBoxAuth';
			// var szArray = this.m_szUserName.split('@');
			// var szUsername = encodeURIComponent(szArray[0]);

			// this.m_Log.Write("nsGMailSMTP.js - logIN - HELLO");

			this.m_HttpComms.clean();
			this.m_HttpComms.addRequestHeader("User-Agent", "User-Agent: Mozilla/5.0 (compatible;)", true);
			this.m_HttpComms.setContentType(0);

			this.m_SessionData = this.m_SessionManager.findSessionData(this.m_szUserName);
			if ( this.m_SessionData && this.m_bReUseSession ) {
				this.m_Log.Write("nsGMailSMTP.js - logIN - Session Data found");
				this.m_HttpComms.setCookieManager(this.m_SessionData.oCookieManager);

				this.serverComms("+OK Your in\r\n");
				this.m_bAuthorised = true;
			} else {
				this.m_Log.Write("nsGMailSMTP.js - logIN - No Session Data found");
				this.m_HttpComms.addValuePair('Email', encodeURIComponent(this.m_szUserName));
				this.m_HttpComms.addValuePair('Passwd', encodeURIComponent(this.m_szPassWord));
				this.m_HttpComms.addValuePair('continue', encodeURIComponent(this.m_szMailURL));

				// this.m_HttpComms.m_bHandleBounce  = false

				this.m_HttpComms.setURI(loginURL);
				this.m_HttpComms.setRequestMethod("POST");

				var bResult = this.m_HttpComms.send(this.loginOnloadHandler);
				if (!bResult) throw new Error('httpConnection returned false');

				this.m_iStage = 0;
			}

			this.m_Log.Write("nsGMailSMTP.js - logIN - END");
			return true;
		}
		catch(e) {
			this.m_Log.DebugDump("nsGMailSMTP.js: logIN : Exception : " + e.name + ".\nError message: " + e.message+ "\n" + e.lineNumber);
			this.serverComms("502 negative vibes from "+this.m_szUserName+"\r\n");
			return false;
		}
	},

	loginOnloadHandler : function(szResponse ,event , mainObject)
	{
		try {
			mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - START"); 
			mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler : " + mainObject.m_iStage);  

			var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);

			//if this fails we've gone somewhere new
			mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - status :" + httpChannel.responseStatus );
			if (httpChannel.responseStatus != 200) 
				throw new Error("return status " + httpChannel.responseStatus);

			switch  ( mainObject.m_iStage ) {
			case 0:
				mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - redirect test");

				var aRedirect = szResponse.match(patternGMailLoginRedirect);
				if ( !aRedirect )
					throw new Error("Login failed. (Wrong username/password?)");

				var szURI = decodeURIComponent(aRedirect[1]);
				mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - redirectURL " + szURI);

				mainObject.m_HttpComms.clean();
				mainObject.m_HttpComms.setContentType(0);
				mainObject.m_HttpComms.addRequestHeader("User-Agent", "User-Agent: Mozilla/5.0 (compatible;)", true);
	
				mainObject.m_HttpComms.setURI(szURI);
				mainObject.m_HttpComms.setRequestMethod("GET");
				var bResult = mainObject.m_HttpComms.send(mainObject.loginOnloadHandler, mainObject);
				if (!bResult) throw new Error("httpConnection returned false");
	
				mainObject.m_szCookieLoginURL = szURI;
	
				mainObject.m_iStage++;
				break;
			case 1:
				if ( szResponse.indexOf("Sign In") > -1 || 
						szResponse.indexOf("NewAccount") > -1 ||
						szResponse.indexOf("Username and password do not match") > -1 ||
						szResponse.indexOf("Sign up for Gmail") > -1)
					throw new Error("Invalid Password");
	
				var szCookies =  httpChannel.getResponseHeader("Set-Cookie");
				mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - login cookies :\n" + szCookies );
	
				var aCookie = szCookies.match(PatternGMailGetLoginCookie);
				if ( aCookie == null)
					throw new Error("Error getting cookies during login");
				// mainObject.m_szGMailAtCookie = aCookie[1];
	
				mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - Getting session cookie...");
	
				var IOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				try {
					var nsIURI = IOService.newURI(mainObject.m_szCookieLoginURL, null, null);
				}
				catch(err) {
					mainObject.m_Log.DebugDump("nsGMailSMTP.js: loginHandler : Exception : " 
						+ err.name 
						+ ".\nError message: " 
						+ err.message);
					mainObject.serverComms("-ERR negative vibes (GMail)\r\n");
					break;
				}
				var oCookieManager = mainObject.m_HttpComms.getCookieManager();
				szCookies = oCookieManager.findCookie(nsIURI);
				mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - session cookies:\n" + szCookies);
	
				mainObject.m_szGMailAtCookie = szCookies.match(PatternGMailGetSessionCookie)[1];
				if ( mainObject.m_szGMailAtCookie == null)
					throw new Error("Error getting session cookie during login");
	
				mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - szGMAIL_AT: " + mainObject.m_szGMailAtCookie);
	
				if ( !mainObject.m_SessionData ) {
					mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - Saving session Data");
					mainObject.m_SessionData = Components.classes["@mozilla.org/SessionData;1"].createInstance();
					mainObject.m_SessionData.QueryInterface(Components.interfaces.nsISessionData);
					mainObject.m_SessionData.szUserName = mainObject.m_szUserName;
	
					var componentData = Components.classes["@mozilla.org/ComponentData;1"].createInstance();
					componentData.QueryInterface(Components.interfaces.nsIComponentData);
					mainObject.m_SessionData.oComponentData = componentData;
				}
				mainObject.m_SessionData.oCookieManager = mainObject.m_HttpComms.getCookieManager();
				mainObject.m_SessionManager.setSessionData(mainObject.m_SessionData);
	
				mainObject.serverComms("235 Your In\r\n");
				mainObject.m_bAuthorised = true;
				break;
			}

			mainObject.m_Log.Write("nsGMailSMTP.js - loginOnloadHandler - END");
		}
		catch(err) {
			mainObject.m_Log.DebugDump("nsGMailSMTP.js: loginHandler : Exception : " + err.name + ".\nError message: " + err.message+ "\n" + err.lineNumber);
			mainObject.serverComms("502 negative vibes from "+mainObject.m_szUserName+"\r\n");
		}
	},

	rawMSG : function (szEmail)
	{
		try {
			this.m_Log.Write("nsGMailSMTP.js - rawMSG - START");   
			this.m_Log.Write("nsGMailSMTP.js - rawMSG " + szEmail);

			if ( this.m_bAuthorised == false )
				return false;

			this.m_iStage =0 ;
			if ( !this.m_Email.parse(szEmail) )
				throw new Error ("Parse Failed")

			var szTo = this.m_Email.headers.getTo(); 
			var szCc = this.m_Email.headers.getCc();
			var szBCC = this.getBcc(szTo, szCc);
			var szSubject = this.m_Email.headers.getSubject();
			szSubject = ( szSubject? szSubject : " ")
			// var szBoundary = this.m_Email.headers.getContentType(3);

			var szMsgBody = " ";

			if ( this.m_Email.txtBody ) {
				szMsgBody = this.m_Email.txtBody.body.getBody();
				this.m_Log.DebugDump("nsGMailSMTP.js: rawMSG: txtBody body: " + szMsgBody);
			}

			this.m_HttpComms.clean();
			this.m_HttpComms.setContentType(1);
			this.m_HttpComms.addRequestHeader("User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8) Gecko/20051111 Firefox/1.5", true);

			this.m_HttpComms.addValuePair('view', 'sm');
			this.m_HttpComms.addValuePair('cmid', '2');
			this.m_HttpComms.addValuePair('at', this.m_szGMailAtCookie);
			this.m_HttpComms.addValuePair('to', (szTo? szTo : "") ); 
			this.m_HttpComms.addValuePair('cc', (szCc? szCc : "") ); 
			this.m_HttpComms.addValuePair('bcc', (szBCC? szBCC : "") ); 
			this.m_HttpComms.addValuePair('subject', szSubject ); //encodeURIComponent

			if ( this.m_Email.htmlBody ) {
				this.m_Log.DebugDump("nsGMailSMTP.js: rawMSG: isHTML");

				this.m_HttpComms.addValuePair('ishtml', "1" );
				szMsgBody = this.m_Email.htmlBody.body.getBody();

				// check for html parts (such as inline images)
/*
				var szData;
				var szParts = this.m_Email.splitHeaderBody(szEmail);

				// var szType = szParts[1].getContentType(1);
				// if (szType.search(/multipart/i)!=-1) {
				if ( szParts.length > 1 ) {
					// this.m_Log.DebugDump("nsGMailSMTP.js: rawMSG: html parts: " + szParts.length );
					szData = szParts[2];

					for ( i=0 ; i< szParts.length ; i++ ) {
						this.m_Log.DebugDump("nsGMailSMTP.js: rawMSG: part " + i + ": " + szParts[i] );
					// this.m_HttpComms.addData(szData, "form-data");
					}
				}
*/
			}

			this.m_HttpComms.addValuePair('msgbody', (szMsgBody? szMsgBody : " ") );
			this.m_Log.DebugDump("nsGMailSMTP.js: rawMSG: body: " + szMsgBody );

			if ( this.m_Email.attachments.length>0 ) {
				this.m_Log.DebugDump("nsGMailSMTP.js: rawMSG: nAttachments: " + this.m_Email.attachments.length );

				for ( i=0 ; i< this.m_Email.attachments.length ; i++ ) {
					var szName = "file" + i;
					var szFileName = this.m_Email.attachments[i].headers.getContentType(4);
					if ( szFileName )
						szName = szFileName;
					else
						szFileName = szName;

					var szContentType = this.m_Email.attachments[i].headers.getContentType(0);
					var szURLCodedBody =  this.m_Email.attachments[i].body.getBody();

					var szMsg = "filename=" + szFileName + "\n" + "Content-Type: " + szContentType + "\n\n" + szURLCodedBody;

					// this.m_HttpComms.addValuePair(szName, encodeURIComponent(szMsg) );
					// this.m_Log.DebugDump("nsGMailSMTP.js: rawMSG: attach[" + i + "]: " + szMsg);

					this.m_HttpComms.addFile(szName, szFileName, this.m_Email.attachments[i].body.getBody() );
					// this.m_Log.DebugDump("nsGMailSMTP.js: rawMSG: attach[" + i + "]: " + this.m_Email.attachments[i].body.getBody() );
				}
			}

			// var szSave = this.m_bSaveCopy ? "yes" : "no";
			// this.m_HttpComms.addValuePair(szName, szSave);

			var szComposeURI = this.m_szMailURL;

			this.m_HttpComms.setURI(szComposeURI);
			this.m_HttpComms.setRequestMethod("POST");
			var bResult = this.m_HttpComms.send(this.composerOnloadHandler);  
			if ( !bResult ) {
				// TODO parse reply to get the failure reason
/*
D(["sr","2",0,"test.vbs is an executable file. For security reasons, Gmail does not allow you to send this type of file.","0",0,[]
,,0,0,0,"",,0,[]
*/ 
				throw new Error("httpConnection returned false");
			}
			this.m_Log.Write("nsGMailSMTP.js - rawMSG - END");
			return true;
		}
		catch(err) {
			this.m_Log.DebugDump("nsGMailSMTP.js: rawMSG : Exception : " + err.name + ".\nError message: " + err.message+ "\n" + err.lineNumber);
			return false;
		}
	},

	composerOnloadHandler : function(szResponse ,event , mainObject)
	{
		try {
			mainObject.m_Log.Write("nsGMailSMTP.js - composerOnloadHandler - START"); 
			mainObject.m_Log.Write("nsGMailSMTP.js - composerOnloadHandler : " + mainObject.m_iStage);  

			var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);

			//if this fails we've gone somewhere new
			mainObject.m_Log.Write("nsGMailSMTP.js - composerOnloadHandler - status :" + httpChannel.responseStatus );
			if (httpChannel.responseStatus != 200) {
	                        mainObject.serverComms("502 Error Sending Email\r\n");
				// throw new Error("return status " + httpChannel.responseStatus);
			}

        		if ( szResponse.indexOf("Your message has been sent.")< 0 ) 
	                        mainObject.serverComms("502 Invalid mail format\r\n");

/*
			mainObject.m_SessionData.oCookieManager = mainObject.m_HttpComms.getCookieManager();
			mainObject.m_SessionData.oComponentData.addElement("szHomeURI",mainObject.m_szHomeURI);
			mainObject.m_SessionManager.setSessionData(mainObject.m_SessionData);
*/
                        mainObject.serverComms("250 OK\r\n");                      
			mainObject.m_Log.Write("nsGMailSMTP.js - composerOnloadHandler - END");
		}
		catch(err) {
			mainObject.m_Log.DebugDump("nsGMailSMTP.js: composerOnloadHandler : Exception : " + err.name + ".\nError message: " + err.message + "\n" + err.lineNumber);
			mainObject.serverComms("502 negative vibes from " + mainObject.m_szUserName + "\r\n");
		}
	},

	escapeStr : function(szMSG)
	{
		var szEncode = escape(szMSG);
		szEncode = szEncode.replace(/%20/gm,"+"); //replace space
		return szEncode;
	},

	getBcc : function (szTo,szCc) 
	{
        try
        {
            this.m_Log.Write("nsGMailSMTP.js - getBcc - START");
            if (this.m_aszTo.length==0) return null;
            this.m_Log.Write("nsGMailSMTP.js - getBcc - szRcptList " + this.m_aszTo);  
            
            var szBcc = null;
            var szAddress = null;
            if (szTo) szAddress = szTo;
            if (szCc) szAddress = (szTo ? (szAddress + ","+ szCc) : szCc);
            this.m_Log.Write("nsGMailSMTP.js - getBcc - szAddress " + szAddress);
           
            if (!szAddress) 
                szBcc = this.m_aszTo;
            else
            {     
                for (j=0; j<this.m_aszTo.length; j++)
                {
                    var regExp = new RegExp(this.m_aszTo[j]);
                    if (szAddress.search(regExp)==-1)
                    {    
                        szBcc? (szBcc += this.m_aszTo[j]) : (szBcc = this.m_aszTo[j]);
                        szBcc +=",";
                    }
                }
            }
            this.m_Log.Write("nsGMailSMTP.js - getBcc szBcc- " + szBcc);
            
            this.m_Log.Write("nsGMailSMTP.js - getBcc - End");
            return szBcc;  
        }
        catch(err)
        {
            this.m_Log.DebugDump("nsGMailSMTP.js: getBcc : Exception : " 
                                                  + err.name 
                                                  + ".\nError message: " 
                                                  + err.message + "\n"
                                                  + err.lineNumber);
                                                  
            return null;
        }
    },

/*
    writeImageFile : function(szData)
    {
        try
        {
            this.m_Log.Write("nsGMailSMTP.js - writeImageFile - End");
            
            var file = Components.classes["@mozilla.org/file/directory_service;1"];
            file = file.getService(Components.interfaces.nsIProperties);
            file = file.get("TmpD", Components.interfaces.nsIFile);
            file.append("suggestedName.jpg");
            file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420); 
           
            var deletefile = Components.classes["@mozilla.org/uriloader/external-helper-app-service;1"];
            deletefile = deletefile.getService(Components.interfaces.nsPIExternalAppLauncher);
            deletefile.deleteTemporaryFileOnExit(file);    
            
            var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"];
            outputStream = outputStream.createInstance( Components.interfaces.nsIFileOutputStream );
            outputStream.init( file, 0x04 | 0x08 | 0x10, 420, 0 );
            
            var binaryStream = Components.classes["@mozilla.org/binaryoutputstream;1"];
            binaryStream = binaryStream.createInstance(Components.interfaces.nsIBinaryOutputStream);
            binaryStream.setOutputStream(outputStream)
            binaryStream.writeBytes( szData, szData.length );
            outputStream.close();
            binaryStream.close();
                       
            var ios = Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService);
            var fileHandler = ios.getProtocolHandler("file")
                                 .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
            var URL = fileHandler.getURLSpecFromFile(file);
            this.m_Log.Write("nsGMailSMTP.js - writeImageFile - path " + URL);
            
            this.m_Log.Write("nsGMailSMTP.js - writeImageFile - End");
            return URL;
        }
        catch(err)
        {
            this.m_Log.DebugDump("nsGMailSMTP.js: writeImageFile : Exception : " 
                                                  + err.name 
                                                  + ".\nError message: " 
                                                  + err.message + "\n"
                                                  + err.lineNumber);
                                                  
            return null;
        }
    },
*/

/*
    openSpamWindow : function(szPath)
    {
        try
        {
            this.m_Log.Write("nsGMailSMTP : openWindow - START");
            
            var params = Components.classes["@mozilla.org/embedcomp/dialogparam;1"]
                                   .createInstance(Components.interfaces.nsIDialogParamBlock);
            params.SetNumberStrings(1);
            params.SetString(0, szPath);           
                      
            var window = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                                  .getService(Components.interfaces.nsIWindowWatcher);
            
            window.openWindow(null, 
                              "chrome://gmail/content/GMail-SpamImage.xul",
                              "_blank", 
                              "chrome,alwaysRaised,dialog,modal,centerscreen",
                              params);
           
            var iResult = params.GetInt(0);
            this.m_Log.Write("nsGMailSMTP : openWindow - " + iResult);
            var szResult =  null;
            if (iResult) 
            {
                szResult = params.GetString(0);
                this.m_Log.Write("nsGMailSMTP : openWindow - " + szResult);
            }
            
            this.m_Log.Write("nsGMailSMTP : openWindow - END");
            return szResult;
        }
        catch(err)
        {
            this.m_Log.DebugDump("nsGMailSMTP: Exception in openWindow : " 
                                               + err.name 
                                               + ".\nError message: " 
                                               + err.message + "\n"
                                               + err.lineNumber);
        }
    },
*/


    ////////////////////////////////////////////////////////////////////////////
    /////  Comms                  

    serverComms : function (szMsg)
    {
        try
        { 
            this.m_Log.Write("nsGMailSMTP.js - serverComms - START");
            this.m_Log.Write("nsGMailSMTP.js - serverComms msg " + szMsg);
            var iCount = this.m_oResponseStream.write(szMsg,szMsg.length);
            this.m_Log.Write("nsGMailSMTP.js - serverComms sent count: " + iCount 
                                                        +" msg length: " +szMsg.length);
            this.m_Log.Write("nsGMailSMTP.js - serverComms - END");  
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsGMailSMTP.js: serverComms : Exception : " 
                                              + e.name 
                                              + ".\nError message: " 
                                              + e.message+ "\n"
                                              + e.lineNumber);
        }
    },
    
     
/******************************************************************************/
/***************** XPCOM  stuff ***********************************************/
/******************************************************************************/
    QueryInterface : function (iid)
    {
        if (!iid.equals(Components.interfaces.nsISMTPDomainHandler) 
        	                && !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_NO_INTERFACE;
            
        return this;
    }
}
 

/******************************************************************************/
/* FACTORY*/
var nsGMailSMTPFactory = new Object();

nsGMailSMTPFactory.createInstance = function (outer, iid)
{
    if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
    
    if (!iid.equals(nsGMailSMTPClassID) && !iid.equals(Components.interfaces.nsISupports))
        throw Components.results.NS_ERROR_INVALID_ARG;
    
    return new nsGMailSMTP();
}


/******************************************************************************/
/* MODULE */
var nsGMailSMTPModule = new Object();

nsGMailSMTPModule.registerSelf = function(compMgr, fileSpec, location, type)
{
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compMgr.registerFactoryLocation(nsGMailSMTPClassID,
                                    "GMailSMTPComponent",
                                    nsGMailSMTPContactID, 
                                    fileSpec,
                                    location, 
                                    type);
}


nsGMailSMTPModule.unregisterSelf = function(aCompMgr, aFileSpec, aLocation)
{
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(nsGMailSMTPClassID, aFileSpec);
}

 
nsGMailSMTPModule.getClassObject = function(compMgr, cid, iid)
{
    if (!cid.equals(nsGMailSMTPClassID))
        throw Components.results.NS_ERROR_NO_INTERFACE;

    if (!iid.equals(Components.interfaces.nsIFactory))
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    return nsGMailSMTPFactory;
}


nsGMailSMTPModule.canUnload = function(compMgr)
{
    return true;
}
/******************************************************************************/


function NSGetModule(compMgr, fileSpec)
{
    return nsGMailSMTPModule; 
}
